# -*- encoding: utf-8 -*-
"""
Configuration file for celery instance

Documentation: https://docs.celeryproject.org/en/v4.4.7/userguide/configuration.html
"""
# Import modules with celery's tasks
imports = (
    'uds.core.managers.PublicationManager',
    'uds.core.workers.AssignedAndUnused',
    'uds.core.workers.DeployedServiceCleaner',
    'uds.core.workers.HangedCleaner',
    'uds.core.workers.PublicationCleaner',
    'uds.core.workers.ScheduledAction',
    'uds.core.workers.SchedulerHouseKeeping',
    'uds.core.workers.ServiceCacheUpdater',
    'uds.core.workers.StatsCollector',
    'uds.core.workers.StuckCleaner',
    'uds.core.workers.SystemCleaners',
    'uds.core.workers.UserServiceCleaner',
    'uds.services.OVirt.OVirtJobs',
    'termidesk.core.workers.FrozenJobs',
)
# The name of default queue for tasks
task_default_queue = 'termidesk'
# Serializer for tasks
task_serializer = 'pickle'
# The serializers "whitelist" for workers
accept_content = ['pickle', 'json']
# url for message broker
broker_url = 'amqp://myuser:mypassword@localhost'
# The number of threads within the worker will execute tasks
worker_concurrency = 1
# The maximum number of seconds 'celery beat' can sleep between checking the schedule
beat_max_loop_interval = 1
