"""
WSGI config for server project.

This module contains the WSGI application used by Django's development server
and any production WSGI deployments. It should expose a module-level variable
named ``application``. Django's ``runserver`` and ``runfcgi`` commands discover
this application via the ``WSGI_APPLICATION`` setting.

Usually you will have the standard Django WSGI application here, but it also
might make sense to replace the whole Django WSGI application with a custom one
that later delegates to the Django one. For example, you could introduce WSGI
middleware here, or combine a Django application with an application of another
framework.

"""
from django.core.wsgi import get_wsgi_application
import os

import six
if six.PY2:
    # 2to3: setdefaultencoding doesn't exist in python 3.
    # Besides, utf-8 is default encoding in python 3
    import sys
    reload(sys) # NOQA
    sys.setdefaultencoding('UTF-8')  # @UndefinedVariable

os.environ.setdefault("DJANGO_SETTINGS_MODULE", "server.settings")

# This application object is used by any WSGI server configured to use this
# file. This includes Django's development server, if the WSGI_APPLICATION
# setting points here.
application = get_wsgi_application()
