# -*- coding: utf-8 -*-
'''
Created on 23 окт. 2018 г.

@author: dvd
'''
from __future__ import unicode_literals

from django import forms
from termidesk.models.License import MAX_SIZE


class LicenseUpload(forms.Form):
    
    
    license_file = forms.FileField(
        required=True
    )
    
    def __init__(self, *args, **kwargs):
        super(LicenseUpload, self).__init__(*args, **kwargs)
        # 2to3: self.fields.items() passed to list()
        for _, field in list(self.fields.items()):
            if field.required:
                field.widget.attrs['required']=''

    def clean_license_file(self):
        license_file = self.cleaned_data.get('license_file')

        if license_file is not None:
            if license_file.size > MAX_SIZE:
                raise forms.ValidationError("Размер файла превышает допустимый")

        try:
            content_data = []
            for chunk in license_file.chunks():
                content_data.append(chunk.decode() if isinstance(chunk, bytes) else chunk)
        except (ValueError, UnicodeDecodeError):
            raise forms.ValidationError("Переданный файл не поддерживается")

        return ''.join(content_data)
