from rest_framework.decorators import api_view, permission_classes
from rest_framework.generics import get_object_or_404
from rest_framework.response import Response
from termidesk.api.permissions import AccessByServicePoolPermission
from uds.models import UserService


@api_view(['GET'])
@permission_classes([AccessByServicePoolPermission])
def settings(request, uuid_actor):
    user_service = get_object_or_404(UserService, uuid=uuid_actor)

    return Response({'debug': user_service.deployed_service.debug_mode})
