import logging

from rest_framework.response import Response
from rest_framework.views import APIView
from uds.models import Authenticator

logger = logging.getLogger(__name__)


class Authenticators(APIView):
    """
    View to list all authenticators.

    get:
    Получение списка аутентификаторов.
    """

    def get(self, request, format=None):
        res = {
            'result':
                [{
                    'authId': auth.id,
                    'authSmallName': str(auth.small_name),
                    'auth': auth.name,
                    'type': auth.getType().__name__
                } for auth in Authenticator.objects.all()]
        }

        return Response(res)
