from rest_framework import serializers


class VersionsSerializer(serializers.Serializer):
    version = serializers.CharField(required=False, allow_blank=True)
    url = serializers.CharField()


class SchemaSerializer(serializers.Serializer):
    version = serializers.CharField()
    versions = VersionsSerializer(required=True, many=True)


class ServerSerializer(serializers.Serializer):
    version = serializers.CharField(required=True)


class ModulesSerializer(serializers.Serializer):
    id = serializers.CharField(required=False, allow_null=True)
    versions = VersionsSerializer(required=False, many=True)


class ApiSerializer(serializers.Serializer):
    schema = SchemaSerializer(required=True)
    server = ServerSerializer(required=True)
    modules = ModulesSerializer(required=True, many=True)
