# -*- encoding: utf-8 -*-

from uds.core.util.State import State
import logging

logger = logging.getLogger(__name__)


def get_special_data_type_provider():
    """ Получение только определенных типов фондов. """
    return ['pksvbrestPlatform', 'oVirtPlatform']


def get_usable_user_services(user_services_object):
    """
    Получение назначенных ВМ

    :param user_services_object: query-объект UserService
    :return: возвращается QuerySet с результатами выборки
    """
    logger.debug('Getting assigned VMs')
    user_services = user_services_object
    logger.debug(
        'Initial UserService has {} item(s).'.format(user_services.count())
    )

    user_services = user_services.filter(state=State.USABLE).exclude(src_ip='')

    logger.debug(
        'Select {} assigned UserServices.'.format(user_services.count())
    )

    return user_services
