# -*- encoding: utf-8 -*-

import logging

from rest_framework import serializers

from uds.models import Authenticator

logger = logging.getLogger(__name__)


class AuthenticatorSerializer(serializers.ModelSerializer):

    uuid = serializers.CharField(required=True)
    name = serializers.CharField(required=True, max_length=128)
    small_name = serializers.CharField(required=True, max_length=128)
    type = serializers.CharField(required=True, max_length=512, source='data_type')

    class Meta:
        model = Authenticator
        fields = ['uuid', 'name', 'small_name', 'type']
