# -*- encoding: utf-8 -*-

import logging

from rest_framework import serializers

from uds.models import User

logger = logging.getLogger(__name__)


class UserSerializer(serializers.ModelSerializer):

    uuid = serializers.CharField(required=True)
    username = serializers.CharField(required=True, max_length=128, source='name')
    name = serializers.CharField(required=True, max_length=128, source='real_name')

    class Meta:
        model = User
        fields = ['uuid', 'username', 'name']
