from django.conf.urls import url
from termidesk.api.external.rubackup.draft.views.assigned import AssignedViewSet
from termidesk.api.external.rubackup.draft.views.provider import ProviderViewSet
from termidesk.api.external.rubackup.draft.views.userservice import UserServiceViewSet
from termidesk.api.external.rubackup.draft.views.workplace import WorkplaceViewSet
from termidesk.api.external.rubackup.draft.views.authenticator import AuthenticatorViewSet
from termidesk.api.external.rubackup.draft.views.user import UserViewSet
from termidesk.api.external.rubackup.draft.views.assigned_workplace import UsersWorkplaceViewSet

app_name = 'draft'

urlpatterns = [
    url(r'^workplaces$', WorkplaceViewSet.as_view({'get': 'list', }), name="workplaces"),
    url(r'^providers$', ProviderViewSet.as_view({'get': 'list', }), name="providers"),
    url(r'^workplaces/(?P<uuid>.+)/assigned$', AssignedViewSet.as_view({'get': 'list', }), name="assigned"),
    url(r'^authenticators$', AuthenticatorViewSet.as_view({'get': 'list', }), name="authenticators"),
    url(r'^authenticators/(?P<auth_uuid>.+)/users$', UserViewSet.as_view({'get': 'list', }), name="users"),
    url(r'^authenticators/(?P<auth_uuid>.+)/users/(?P<user_uuid>.+)/workplaces$',
        UsersWorkplaceViewSet.as_view({'get': 'list', }), name="users_workplaces"),
    url(
        r'^workplaces/(?P<uuid>.+)/replace$',
        UserServiceViewSet.as_view({'patch': 'partial_update', }),
        name="replace"
    ),
]
