# -*- encoding: utf-8 -*-

import logging

from django.shortcuts import get_object_or_404

from termidesk.api.external.rubackup.draft.helpers import get_usable_user_services
from termidesk.api.external.rubackup.draft.serializers.userservice import UserServiceSerializer
from termidesk.api.external.rubackup.draft.views.common_viewset import CommonViewSet
from uds.models.ServicesPool import DeployedService

logger = logging.getLogger(__name__)


class AssignedViewSet(CommonViewSet):
    """
       list:
       Получить список назначенных пользователям экземпляров рабочих мест.
    """
    serializer_class = UserServiceSerializer
    http_method_names = ['get']

    def get_queryset(self):
        workplace_uuid = self.kwargs['uuid']
        workplace = get_object_or_404(DeployedService, uuid=workplace_uuid)

        # Получение списка назначенных ВМ
        return get_usable_user_services(workplace.userServices)
