# -*- encoding: utf-8 -*-

import logging

from termidesk.api.external.rubackup.draft.helpers import get_special_data_type_provider
from termidesk.api.external.rubackup.draft.serializers.provider import ProviderSerializer
from termidesk.api.external.rubackup.draft.views.common_viewset import CommonViewSet
from uds.models.Provider import Provider

logger = logging.getLogger(__name__)


class ProviderViewSet(CommonViewSet):
    """
       list:
       Получить список поставщиков ресурсов.
    """
    queryset = Provider.objects.filter(
        data_type__in=get_special_data_type_provider()
    ).all()
    serializer_class = ProviderSerializer
    http_method_names = ['get']
