# -*- encoding: utf-8 -*-
from rest_framework.generics import get_object_or_404

from termidesk.api.external.rubackup.draft.serializers.user import UserSerializer
from termidesk.api.external.rubackup.draft.views.common_viewset import CommonViewSet
from uds.core.util.State import State
from uds.models import Authenticator


class UserViewSet(CommonViewSet):
    """
       list:
       Получить список пользователей в домене аутентификации.
    """

    serializer_class = UserSerializer
    http_method_names = ['get']

    def get_queryset(self):
        authenticator_uuid = self.kwargs['auth_uuid']
        authenticator = get_object_or_404(Authenticator, uuid=authenticator_uuid)
        return authenticator.users.filter(state=State.ACTIVE)
