# -*- encoding: utf-8 -*-

import logging

from termidesk.api.external.rubackup.draft.helpers import get_special_data_type_provider
from termidesk.api.external.rubackup.draft.serializers.workplace import WorkplaceSerializer
from termidesk.api.external.rubackup.draft.views.common_viewset import CommonViewSet
from uds.models.ServicesPool import DeployedService

logger = logging.getLogger(__name__)


class WorkplaceViewSet(CommonViewSet):
    """
       list:
       Получить список фондов рабочих мест.
    """
    queryset = DeployedService.objects.filter(
        service__provider__data_type__in=get_special_data_type_provider()
    ).all()
    serializer_class = WorkplaceSerializer
    http_method_names = ['get']
