'''
Created on 10 февр. 2022 г.

@author: dvd
'''
from rest_framework.schemas.openapi import AutoSchema
from .serializers.gui import GUICharFieldSerializer
from .serializers.gui import GUIBoolFieldSerializer

import logging

logger = logging.getLogger(__name__)


class GuiFieldsSchema(AutoSchema):
    serializers_classes = [
        GUICharFieldSerializer,
        GUIBoolFieldSerializer
    ]

    def get_components(self, path, method):

        components = dict()
        for clazz in self.serializers_classes:
            serializer = clazz()
            component_name = self.get_component_name(serializer)
            content = self.map_serializer(serializer)
            components[component_name] = content

        return components

    def get_operation(self, path, method):
        res = AutoSchema.get_operation(self, path, method)

        schema = res['responses']['200']['content']['application/json']['schema']

        refs = []
        for clazz in self.serializers_classes:
            serializer = clazz()
            refs.append(self._get_reference(serializer))

        schema['items'] = {
            'anyOf': refs
        }

        return res
