import logging

from rest_framework import serializers
from uds.models.User import User

logger = logging.getLogger(__name__)


class AuthShortUserSerializer(serializers.ModelSerializer):
    """ Сериализатор c сокрашенным набором полей для группы и пользователей домена аутентификации. """
    id = serializers.CharField(source='uuid', required=False, read_only=True)
    last_access = serializers.CharField()  # Django Model и DRF имеют разные форматы даты и времени

    class Meta:
        model = User
        fields = ['id', 'name', 'real_name', 'state', 'last_access', ]


class AuthServicePoolSerializer(serializers.Serializer):
    """ Сериализатор c набором полей рабочих мест для группы и пользователей домена аутентификации. """
    id = serializers.CharField(source='uuid', required=False, read_only=True)
    name = serializers.CharField()
    thumb = serializers.CharField()
    user_services_count = serializers.IntegerField()
    state = serializers.CharField()
