# -*- encoding: utf-8 -*-

from rest_framework import serializers
from uds.models.Log import Log


class MonitoringSerializer(serializers.ModelSerializer):
    date = serializers.SerializerMethodField()
    level = serializers.IntegerField(required=True, min_value=0)
    source = serializers.CharField(required=True, max_length=128)
    message = serializers.CharField(source='data', required=True, max_length=512)

    class Meta:
        model = Log
        fields = ['date', 'level', 'source', 'message']

    def get_date(self, instance):
        return int(instance.created.timestamp())
