from rest_framework import serializers
from uds.models.Transport import Transport


class TransportListSerializer(serializers.ModelSerializer):
    id = serializers.UUIDField(source='uuid', required=False, read_only=True)
    type = serializers.SerializerMethodField()

    class Meta:
        model = Transport
        fields = ['id', 'name', 'comments', 'type', 'priority']

    def get_type(self, instance):
        if not isinstance(instance, Transport):
            return ''

        return instance.getType()


class TransportServicePoolSerializer(serializers.Serializer):
    id = serializers.UUIDField()
    tags = serializers.ListField()

    class Meta:
        fields = ['id', 'tags']
