from rest_framework import serializers
from uds.models.User import User


class UserListSerializer(serializers.ModelSerializer):
    """ Сериализатор получения пользователей фонда рабочих мест. """
    id = serializers.UUIDField(source='uuid', required=False, read_only=True)
    auth_id = serializers.UUIDField(source='manager.uuid')
    auth_name = serializers.CharField(source='manager.name')
    type = serializers.SerializerMethodField()

    class Meta:
        model = User
        fields = ['id', 'auth_id', 'name', 'comments', 'state', 'type', 'auth_name']

    def get_type(self, instance):
        return 'user'


class UserSerializer(serializers.Serializer):
    """ Сериализатор для добавления пользователя в фонд рабочих мест. """
    domain = serializers.UUIDField()
    id = serializers.UUIDField()
    tags = serializers.ListField()

    class Meta:
        fields = ['domain', 'id', 'tags']
