'''
Created on 8 февр. 2022 г.

@author: dvd
'''
# -*- encoding: utf-8 -*-

from termidesk.api.permissions import AccessPermission
from ..serializers.gui import GuiFieldsSerializer
from ..serializers.network import NET_STRING_TOOLTIP
from ..schemas import GuiFieldsSchema
from ..helpers import GuiHelper

from rest_framework import generics
from django.utils.translation import ugettext
from uds.core.ui import gui

import logging

logger = logging.getLogger(__name__)


class NetworksGui(generics.ListAPIView):
    permission_classes = [AccessPermission]
    serializer_class = GuiFieldsSerializer
    schema = GuiFieldsSchema(operation_id_base='WebuiNetworksGuiFields')

    def get_queryset(self):
        net_string_custom_fields = {
                'name': 'net_string',
                'value': '',
                'label': ugettext('Диапазон'),
                'tooltip': ugettext(
                    NET_STRING_TOOLTIP),
                'type': gui.InputField.TEXT_TYPE,
                'order': 100,  # At the end
            }
        gui_default_fields = GuiHelper.add_default_fields([], ['name', 'tags'])
        res = GuiHelper.add_field(gui_default_fields, net_string_custom_fields)
        return sorted(res, key=lambda f: f['gui']['order'])
