import json


class RecordDTO:
    """
    Контейнер для хранения структуры записи аудита.

    Этот класс в будущем можно переделать на dataclass(>=python3.7).
    """

    def __init__(self, timestamp: str, event: str, version: int, data: tuple):
        self.timestamp = timestamp
        self.event = event
        self.version = version
        self.data = data

    def get_json_params(self):
        return json.dumps(self.__dict__, sort_keys=False, ensure_ascii=False)


class RecordSyslog:
    """
    Контейнер для хранения структуры записи в syslog событий аудита.

    Этот класс в будущем можно переделать на dataclass(>=python3.7).
    """

    def __init__(self, event: str, version: int, data: tuple):
        self.event = event
        self.version = version
        self.data = data

    def __get_json_params(self):
        return json.dumps(self.__dict__, sort_keys=False, ensure_ascii=False)

    def get_message(self):
        return "[termidesk] {0}".format(self.__get_json_params())
