from django.http import HttpResponse
from django.shortcuts import get_object_or_404
from django_otp.plugins.otp_totp.models import TOTPDevice
from termidesk.core.auths.auth_2fa import check_access_on_second_step


class QRCodeViewMixin:

    @check_access_on_second_step
    def qrcode(self, request):
        """ Формирование QR кода для приложения. """
        device = get_object_or_404(TOTPDevice, pk=request.GET.get('pk'))

        try:
            import qrcode
            import qrcode.image.svg

            img = qrcode.make(device.config_url, image_factory=qrcode.image.svg.SvgImage)
            response = HttpResponse(content_type='image/svg+xml')
            img.save(response)
        except ImportError:
            response = HttpResponse('', status=503)

        return response
