# -*- coding: utf-8 -*-

from __future__ import unicode_literals

import six


def initialize():
    '''
    This imports all packages that are descendant of this package, and, after that,
    it register all subclases of service provider as
    '''
    import os.path
    import pkgutil
    import sys
    from uds.core import jobs
    from uds.core.managers.TaskManager import TaskManager

    # Dinamycally import children of this package.
    pkgpath = os.path.dirname(sys.modules[__name__].__file__)
    for _, name, _ in pkgutil.iter_modules([pkgpath]):
        if six.PY3:
            # Python 3 removes negative 'level' parameter in __import__ function
            __import__(name, globals(), locals(), [], 1)
        else:
            __import__(name, globals(), locals())

    p = jobs.Job
    # This is marked as error in IDE, but it's not (__subclasses__)
    for cls in p.__subclasses__():
        # Limit to autoregister just workers jobs inside this module

        if cls.__module__[0:22] == 'termidesk.core.workers':
            TaskManager.registerJob(cls)
