# -*- encoding: utf-8 -*-

# Маска для чувствительных данных. Вместо пароля будет отображаться значение константы.
from termidesk.audit.events import CLI_SYSTEM_CONFIG_CHANGED_V1

SENSITIVE_DATA_MASK = '*'


def get_system_username() -> str:
    """Получение имени системного пользователя"""
    import getpass
    system_user_name = getpass.getuser()
    return system_user_name


def raise_cli_system_config_changed_event(section_name: str, parameter_key: str, parameter_new_value: str,
                                          is_sensitive: bool = False, username: str = None) -> None:
    """Вызов события аудита при изменении системных настроек из командной строки"""
    if username is None:
        username = get_system_username()

    # Маскировка чувствительных данных (паролей и т. д.)
    new_value = SENSITIVE_DATA_MASK if is_sensitive else parameter_new_value

    event = CLI_SYSTEM_CONFIG_CHANGED_V1(
        username=username,
        section_name=section_name,
        parameter_key=parameter_key,
        parameter_value=new_value,
    ).generate_event()

    import sys
    sys.audit(*event)