# -*- coding: utf-8 -*-
from __future__ import unicode_literals

import argparse
import re


def positive_int_type(val):
    """ Проверка передачи положительного числа. """
    _only_digits(val)

    ivalue = int(val)
    if ivalue <= 0:
        error = "Positive value above zero required: {}.".format(val)
        raise argparse.ArgumentTypeError(error)
    return ivalue


def positive_int_or_zero_type(val):
    """ Проверка передачи положительного числа или нуля. """
    _only_digits(val)

    return int(val)


def _only_digits(val):
    if re.search("(?u)[^0-9]", val):
        error = "Allowed chars: 0-9"
        raise argparse.ArgumentTypeError(error)
