# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from django.core.management.base import BaseCommand, CommandParser
from abc import ABCMeta, abstractmethod


class CommonCommand(BaseCommand):
    """ Основной класс для создания системных команд для сервисов. """
    __metaclass__ = ABCMeta

    SUBPARSERS_DEST = "subcommand"

    subparsers = None

    @abstractmethod
    def add_arguments(self, parser):

        class SubParser(CommandParser):
            def __init__(self, **kwargs):
                super(SubParser, self).__init__(**kwargs)

        self.subparsers = parser.add_subparsers(
            title="subcommands",
            dest=self.SUBPARSERS_DEST,
            parser_class=SubParser
        )

    @abstractmethod
    def handle(self, *args, **options):
        """
        Базовая логика.
        В данном методе необходимо задать все подкоманды.
        """
