"""Модуль содержит классы-примеси для подкоманд установки"""
# -*- coding: utf-8 -*-
from __future__ import unicode_literals


class InstallMixin:
    """Обработка ошибок для команд установки"""
    def __init__(self, style):
        self.style = style

    def show_error(self, stdout, error_exception, name_of_service):
        """Вывод сообщения об ошибке"""
        message = str(error_exception)
        stdout.write(
            self.style.ERROR('Установка {} не выполнена. '.format(
                name_of_service) + message)
        )

    def show_success(self, stdout, name_of_service):
        """Вывод сообщения об успешном завершении"""
        stdout.write(
            self.style.SUCCESS('Установка {} прошла успешно'.format(
                name_of_service
            ))
        )
