# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from abc import ABCMeta, abstractmethod


class Subcommand(object):
    __metaclass__ = ABCMeta

    SUBCOMMAND = None

    stdout = None
    stderr = None
    style = None

    def __init__(self, style):
        self.style = style

    @abstractmethod
    def handle_subcommand(self, options, stdout, stderr):
        """
        Основной метод указания бизнес-логики команды.
        :param options:
        :param stdout: Параметр отвечающий за вывод сообщений
        :param stderr: Параметр отвечающий за вывод ошибок
        :return:
        """

    @abstractmethod
    def add_arguments_subcommand(self, parser):
        """ Установка аргументов для команды сервиса. """

    @abstractmethod
    def add_subparser(self, subparsers):
        """ Установка субпарсера для работы с командой. """
