from __future__ import unicode_literals

import sys

from termidesk.management.commands.common.common_command import CommonCommand
from termidesk.management.commands.subcommands.config.list import ListCommand
from termidesk.management.commands.subcommands.config.set import SetCommand


class Command(CommonCommand):
    help = "Работа с системными настройками"

    list_command = None
    set_command = None

    def add_arguments(self, parser):
        super(Command, self).add_arguments(parser)
        self.list_command = ListCommand(self.style)
        self.list_command.add_subparser(self.subparsers)

        self.set_command = SetCommand(self.style)
        self.set_command.add_subparser(self.subparsers)

    def handle(self, **options):
        subcommand = options.get('subcommand')

        if not subcommand:
            self.print_help('manage.py', 'tdsk_config')
            sys.exit(1)

        if subcommand == self.list_command.SUBCOMMAND:
            return self.list_command.handle_subcommand(
                options,
                self.stdout,
                self.stderr
            )

        if subcommand == self.set_command.SUBCOMMAND:
            return self.set_command.handle_subcommand(
                options,
                self.stdout,
                self.stderr
            )

        self.stderr.write(
            self.style.ERROR(
                'Не удалось обработать команду "{}", доступна только команда "list"'.format(subcommand)
            )
        )
        sys.exit(1)
