# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from termidesk.management.commands.common.common_command import CommonCommand
from termidesk.management.commands.subcommands.pool.create import CreateCommand
from termidesk.management.commands.subcommands.pool.list import ListCommand


class Command(CommonCommand):
    help = '''Работа с фондами рабочих мест.'''

    create_command = None
    list_command = None

    def add_arguments(self, parser):
        super(Command, self).add_arguments(parser)
        self.create_command = CreateCommand(self.style)
        self.create_command.add_subparser(self.subparsers)

        self.list_command = ListCommand(self.style)
        self.list_command.add_subparser(self.subparsers)

    def handle(self, *args, **options):
        subcommand = options.get('subcommand')

        if subcommand == self.create_command.SUBCOMMAND:
            return self.create_command.handle_subcommand(
                options,
                self.stdout,
                self.stderr
            )

        if subcommand == self.list_command.SUBCOMMAND:
            return self.list_command.handle_subcommand(
                options,
                self.stdout,
                self.stderr
            )

        self.stdout.write(
            self.style.ERROR(
                'Не удалось обработать команду '.format(subcommand)
            )
        )
