from django.db import migrations, models
from django.db import connection


def forwards_func(apps, schema_editor):
    pass


def reverse_func(apps, schema_editor):
    """ Очищение и удаление взаимосвязей с разрешениями, если они были созданы. """
    Permission = apps.get_model('auth', 'Permission')
    permission_read = Permission.objects.filter(codename='test.read').get()
    permission_write = Permission.objects.filter(codename='test.write').get()
    with connection.cursor() as cursor:
        query = 'DELETE FROM uds_user_api_permissions WHERE permission_id IN ({}, {})'.format(
            permission_read.id, permission_write.id
        )
        cursor.execute(query)
    permission_read.delete()
    permission_write.delete()


class Migration(migrations.Migration):
    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='UserPermissionAPI',
            fields=[
                ('id',
                 models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
            ],
            options={
                'permissions': (
                ('UserPermissionAPI.test.read', 'Чтение эндпоинта test'), ('UserPermissionAPI.test.write', 'Запись эндпоинта test')),
                'managed': False,
                'default_permissions': (),
            },
        ),
        migrations.RunPython(forwards_func, reverse_func),
    ]
