# Generated by Django 2.2.17 on 2021-10-04 13:50

from django.db import migrations

# Константы на момент создания миграции
PREFIX_PERMISSION = 'UserPermission'
PREFIX_MODELS = 'models'

SERVICE_POOL_GROUP_CREATE = '.'.join([PREFIX_PERMISSION, PREFIX_MODELS, 'create_ServicesPoolGroup'])
SERVICE_POOL_GROUP_CHANGE = '.'.join([PREFIX_PERMISSION, PREFIX_MODELS, 'change_ServicesPoolGroup'])
SERVICE_POOL_GROUP_DELETE = '.'.join([PREFIX_PERMISSION, PREFIX_MODELS, 'delete_ServicesPoolGroup'])
SERVICE_POOL_GROUP_VIEW = '.'.join([PREFIX_PERMISSION, PREFIX_MODELS, 'view_ServicesPoolGroup'])

# Правила переименования
RENAME_MAP = [
        { 
            'codename': SERVICE_POOL_GROUP_CREATE, 
            'old': 'Создание групп ВАРМ', 
            'new': 'Создание групп рабочих мест'
        },
        { 
            'codename': SERVICE_POOL_GROUP_CHANGE, 
            'old': 'Редактирование групп ВАРМ', 
            'new': 'Редактирование групп рабочих мест'
        },
        { 
            'codename': SERVICE_POOL_GROUP_DELETE, 
            'old': 'Удаление групп ВАРМ', 
            'new': 'Удаление групп рабочих мест'
        },
        { 
            'codename': SERVICE_POOL_GROUP_VIEW, 
            'old': 'Просмотр групп ВАРМ', 
            'new': 'Просмотр групп рабочих мест'
        },
    ]

def rename_service_pool_groups_permissons(apps, schema_editor):
    permission = apps.get_model("auth", "Permission")
    
    for perm in RENAME_MAP:
        permission.objects.filter(codename=perm['codename'], name=perm['old']).update(name=perm['new'])

def revert_rename(apps, schema_editor):
    permission = apps.get_model("auth", "Permission")
    
    for perm in RENAME_MAP:
        permission.objects.filter(codename=perm['codename'], name=perm['new']).update(name=perm['old'])

class Migration(migrations.Migration):

    dependencies = [
        ('termidesk', '0009_auto_20211004_1342'),
    ]

    operations = [
        migrations.RunPython(rename_service_pool_groups_permissons, 
                             reverse_code=revert_rename)
    ]
