# Generated by Django 2.2.17 on 2021-10-18 19:12

from django.db import migrations


# Константы на момент создания миграции
PREFIX_PERMISSION = 'UserPermission'
PREFIX_MODELS = 'models'

CONFIG_VIEW = '.'.join([PREFIX_PERMISSION, PREFIX_MODELS, 'view_Config'])
CONFIG_CHANGE = '.'.join([PREFIX_PERMISSION, PREFIX_MODELS, 'change_Config'])

# Правила переименования
RENAME_MAP = [
        {
            'codename': CONFIG_VIEW,
            'old': 'Просмотр системных настроек',
            'new': 'Просмотр системных параметров'
        },
        {
            'codename': CONFIG_CHANGE,
            'old': 'Изменение системных настроек',
            'new': 'Изменение системных параметров'
        },
    ]


def rename_system_permission_descriptions(apps, schema_editor):
    permission = apps.get_model("auth", "Permission")

    for perm in RENAME_MAP:
        permission.objects.filter(codename=perm['codename'], name=perm['old']).update(name=perm['new'])


def revert_rename(apps, schema_editor):
    permission = apps.get_model("auth", "Permission")

    for perm in RENAME_MAP:
        permission.objects.filter(codename=perm['codename'], name=perm['new']).update(name=perm['old'])


class Migration(migrations.Migration):

    dependencies = [
        ('termidesk', '0012_auto_20211020_1722'),
    ]

    operations = [
        migrations.RunPython(rename_system_permission_descriptions,
                             reverse_code=revert_rename)
    ]
