# Generated by Django 2.2.17 on 2021-10-25 16:48

from django.db import migrations

# Константы на момент создания миграции
PREFIX_PERMISSION = 'UserPermission'
PREFIX_MODELS = 'models'

LOG_VIEW = '.'.join([PREFIX_PERMISSION, PREFIX_MODELS, 'view_Log'])

# Правила переименования
RENAME_MAP = [
    {
        'codename': LOG_VIEW,
        'old': 'Просмотр логов',
        'new': 'Просмотр мониторинга',
    },
]


def rename_system_permission_descriptions(apps, schema_editor):
    permission = apps.get_model("auth", "Permission")

    for perm in RENAME_MAP:
        permission.objects.filter(codename=perm['codename'], name=perm['old']).update(name=perm['new'])


def revert_rename(apps, schema_editor):
    permission = apps.get_model("auth", "Permission")

    for perm in RENAME_MAP:
        permission.objects.filter(codename=perm['codename'], name=perm['new']).update(name=perm['old'])


class Migration(migrations.Migration):
    dependencies = [
        ('termidesk', '0014_auto_rename_permission_to_view_monitoring'),
    ]

    operations = [
        migrations.RunPython(rename_system_permission_descriptions,
                             reverse_code=revert_rename)
    ]
