# Generated by Django 2.2.17 on 2021-11-17 15:50

from django.db import migrations


permission_params = {
    "name": "Управление суперадминистраторами",
    "codename": "UserPermission.security.manage_superadmins",
}


def remove_permission(apps, schema_editor):
    permission = apps.get_model("auth", "Permission")

    permission.objects.filter(**permission_params).delete()


def revert_remove(apps, schema_editor):
    permission = apps.get_model("auth", "Permission")
    content_types = apps.get_model('contenttypes', 'ContentType')
    permission_content_type = content_types.objects.get(app_label='termidesk', model='userpermission')
    restore_permission_params = {
        "content_type": permission_content_type,
    }
    restore_permission_params.update(permission_params)
    permission.objects.create(**restore_permission_params)


class Migration(migrations.Migration):

    dependencies = [
        ('termidesk', '0018_auto_remove_manage_superadmins'),
    ]

    operations = [
        migrations.RunPython(remove_permission,
                             reverse_code=revert_remove)
    ]
