from django.db import migrations


def enable_rbac(apps, schema_editor):
    Config = apps.get_model("uds", "Config")

    Config.objects.filter(section='Experimental', key='experimental.rbac.enabled').update(value=1)


def disable_rbac(apps, schema_editor):
    Config = apps.get_model("uds", "Config")

    Config.objects.filter(section='Experimental', key='experimental.rbac.enabled').update(value=0)


class Migration(migrations.Migration):
    dependencies = [
        ('termidesk', '0020_change_content_type_workplace_permission'),
    ]

    operations = [
        migrations.RunPython(enable_rbac, reverse_code=disable_rbac)
    ]
