import os

import config
from django.db import migrations

LOCATION = config.LICENSE_STORAGE_FOLDER
LICENSE_FILE = 'license.key'
LICENSE_FULL_PATH = "{}/{}".format(LOCATION, LICENSE_FILE)


def transfer_from_file_to_db(apps, schema_editor):
    if not os.path.isfile(LICENSE_FULL_PATH):
        return

    with open(LICENSE_FULL_PATH, 'r') as license_file:
        license = license_file.read()

    license_model = apps.get_model("termidesk", "License")
    if license is not None:
        license_model.objects.create(name='license.key', data=license)


def transfer_from_db_to_file(apps, schema_editor):
    pass


class Migration(migrations.Migration):
    dependencies = [
        ('termidesk', '0023_license'),
    ]

    operations = [
        migrations.RunPython(transfer_from_file_to_db, transfer_from_db_to_file)
    ]
