import django.db.models.deletion
from django.db import migrations, models


class Migration(migrations.Migration):
    dependencies = [
        ('uds', '0047_remove_deprecated_transport'),
        ('termidesk', '0024_transport_license_in_db'),
    ]

    operations = [
        migrations.CreateModel(
            name='PolicyDeployedService',
            fields=[
                ('id', models.AutoField(
                    auto_created=True, primary_key=True, serialize=False, verbose_name='ID'
                )),
                ('uuid', models.CharField(default=None, max_length=50, null=True, unique=True)),
                ('name', models.CharField(db_index=True, max_length=128)),
                ('data_type', models.CharField(max_length=128)),
                ('data', models.TextField(default='')),
                ('comments', models.CharField(max_length=256)),
                ('deployed_service',
                 models.ForeignKey(
                     on_delete=django.db.models.deletion.CASCADE, related_name='policies',
                     to='uds.DeployedService'
                 )),
            ],
            options={
                'db_table': 'termidesk_policy_deployed_service',
                'ordering': ('name',),
                'abstract': False,
            },
        ),
    ]
