from django.core.exceptions import ValidationError
from django.db import models

MAX_SIZE = 1024 * 1024  # 1MiB


def validate_max_size(value):
    if value.size > MAX_SIZE:
        raise ValidationError('File too large. Size should not exceed 1 MiB.')


class License(models.Model):
    name = models.CharField(max_length=36, unique=True)
    data = models.FileField(max_length=MAX_SIZE, validators=[validate_max_size])
