from django.shortcuts import get_object_or_404
from uds.models.ManagedObjectModel import ManagedObjectModel


class PolicyGlobal(ManagedObjectModel):
    class Meta(ManagedObjectModel.Meta):
        ordering = ("name",)
        app_label = "termidesk"
        db_table = "%s_%s" % (app_label, "policy_global")

    def getType(self):
        from termidesk.core.policies.utils import registry

        return registry().lookup(self.data_type)

    def get_value(self):
        return self.getInstance().get_value()

    @staticmethod
    def get_by_type(type_policy: str):
        return get_object_or_404(PolicyGlobal, data_type=type_policy)

    @staticmethod
    def get_policies_by_types():
        """ Объекты политик собранные по типам. """
        return {policy.data_type: policy for policy in PolicyGlobal.objects.all()}
