# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from threading import Lock, Thread
from termidesk.core.util.singleton import SingletonMeta
import logging
logger = logging.getLogger(__name__)

class MediatorService(metaclass=SingletonMeta):
    """
    Глобальный сервис-фасад для преднастроенного медиатора событий от различных компонент 
    приложения.
    """

    def __init__(self, mediator):
        self._mediator = mediator
        
    def notify(self, *args, **kwargs):
        self._mediator.notify(*args, **kwargs)

def event_mediator():
    """ Заводской метод для получения сервиса """
    return MediatorService()