# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from uds.core.util.Config import GlobalConfig
from uds.core.util import Config
import uds
import termidesk

import logging

logger = logging.getLogger(__name__)

from uds.core.ui import theme

def patch_themes():
    import os
    old_init_themes = GlobalConfig.initThemes
    
    @staticmethod
    def initThemes():
        logger.debug('Patched Init themes')

        themes = []
        try:
            for d in os.listdir(os.path.join(os.path.dirname(termidesk.__file__), 'templates', 'termidesk')):
                if d == 'admin':
                    continue
                if d == 'admin2':
                    continue
                if d == 'clients':
                    continue
                themes.append(d)
        except Exception as e:
            pass
        
        GlobalConfig.THEME.setParams(themes)
    
    
    old_tpl_select = theme.template
    
    def termidesk_template(template_name):
        theme_path = GlobalConfig.THEME.get(True)
        
        checked_path = os.path.join(os.path.dirname(termidesk.__file__), 'templates', 'termidesk', theme_path, template_name)
        logger.debug('tpl select: checked path - {}'.format(checked_path))
        if os.path.exists(checked_path):
            return 'termidesk/{}/{}'.format(theme_path, template_name)
        else:
            return 'termidesk/{}/{}'.format('html5', template_name)
    
    GlobalConfig.initThemes = initThemes
    theme.template = termidesk_template

def patch_default_images():
    from .core.ui import images as termidesk_images
    from uds.core.ui import images as uds_images
    uds_images.DEFAULT_IMAGE = termidesk_images.DEFAULT_IMAGE
    uds_images.DEFAULT_IMAGE_BASE64 = termidesk_images.DEFAULT_IMAGE_BASE64
    
    uds_images.DEFAULT_THUMB = termidesk_images.DEFAULT_THUMB
    uds_images.DEFAULT_THUMB_BASE64 = termidesk_images.DEFAULT_THUMB_BASE64