// Generated by CoffeeScript 2.3.0
(function() {
  // api-tools.js
  // jshint strict: true
  var DefaultLocale, RequiredDateMethods, _strftime, dateToUTC, dayNames, hours12, initialsOf, localizedStrftime, monthNames, namespace, ordinal, pad, quacksLikeDate, strftime, strftimeTZ, strftimeUTC, weekNumber;

  (function(api, $, undefined_) {
    "use strict";
    api.tools = {
      base64: function(s) {
        return window.btoa(unescape(encodeURIComponent(s)));
      },
      input2timeStamp: function(inputDate, inputTime) {
        var tmp, v;
        // Just parses date & time in two separate inputs
        // inputTime is in format hours:minutes
        if (inputDate === null || inputDate === void 0) {
          v = new Date(0);
        } else {
          tmp = inputDate.split('-');
          v = new Date(tmp[0], parseInt(tmp[1]) - 1, tmp[2]);
        }
        if (inputTime !== null && inputTime !== void 0) {
          tmp = inputTime.split(':');
          if (v.getTime() !== 0) {
            v.setHours(tmp[0]);
            v.setMinutes(tmp[1]);
          } else {
            return parseInt(tmp[0]) * 3600 + parseInt(tmp[1]) * 60;
          }
        }
        return v.getTime() / 1000;
      },
      strCut: function(str, maxLen) {
        var first, mid, remain, sl;
        if (maxLen < 3) {
          maxLen = 3;
        }
        sl = str.length;
        if (str.length > maxLen) {
          mid = Math.floor(maxLen / 2);
          first = mid - 1;
          remain = maxLen - mid - 2;
          return str = str.substr(0, first) + "..." + str.substr(sl - remain);
        }
      },
      capitalize: function(str) {
        str = str.toLowerCase();
        return str.substr(0, 1).toUpperCase() + str.substr(1);
        return str;
      },
      isEmpty: function(obj) {
        return $.isEmptyObject(obj);
      },
      random: function() {
        return Math.random().toString().split(".")[1];
      },
      cleanWhiteSpaces: function(str) {
        return str.split(' ').join('');
      }
    };
  })(window.api = window.api || {}, jQuery);

  // Insert strftime into tools

  //strftime
  //github.com/samsonjs/strftime
  //@_sjs

  //Copyright 2010 - 2013 Sami Samhuri <sami@samhuri.net>

  //MIT License
  //http://sjs.mit-license.org

  initialsOf = function(arr) {
    var res, v;
    res = [];
    for (v in arr) {
      res.push(arr[v].substr(0, 3));
    }
    return res;
  };

  // Added this to convert django format strings to c format string
  // This is ofc, a "simplified" version, aimed to use date format used by
  // DJANGO
  // daylight saving
  // if it is leap year
  // Not so sure, not important i thing anyway :-)
  // english ordinal suffix for day of month
  // number of days of specified month, not important
  // microseconds
  // Seconds since EPOCH, not used
  // Time zone offset in seconds, replaced by offset
  // in ours/minutes :-)
  strftime = function(fmt, d, locale) {
    return _strftime(fmt, d, locale);
  };

  // locale is optional
  strftimeTZ = function(fmt, d, locale, timezone) {
    if (typeof locale === "number" && (timezone == null)) {
      timezone = locale;
      locale = null;
    }
    return _strftime(fmt, d, locale, {
      timezone: timezone
    });
  };

  strftimeUTC = function(fmt, d, locale) {
    return _strftime(fmt, d, locale, {
      utc: true
    });
  };

  localizedStrftime = function(locale) {
    return function(fmt, d, options) {
      return strftime(fmt, d, locale, options);
    };
  };

  // d, locale, and options are optional, but you can't leave
  // holes in the argument list. If you pass options you have to pass
  // in all the preceding args as well.

  // options:
  // - locale [object] an object with the same structure as DefaultLocale
  // - timezone [number] timezone offset in minutes from GMT
  _strftime = function(fmt, d, locale, options) {
    var timestamp;
    options = options || {};
    // d and locale are optional so check if d is really the locale
    if (d && !quacksLikeDate(d)) {
      locale = d;
      d = null;
    }
    d = d || new Date();
    locale = locale || DefaultLocale;
    locale.formats = locale.formats || {};
    // Hang on to this Unix timestamp because we might mess with it directly
    // below.
    timestamp = d.getTime();
    if (options.utc || typeof options.timezone === "number") {
      d = dateToUTC(d);
    }
    if (typeof options.timezone === "number") {
      d = new Date(d.getTime() + (options.timezone * 60000));
    }
    // Most of the specifiers supported by C's strftime, and some from Ruby.
    // Some other syntax extensions from Ruby are supported: %-, %_, and %0
    // to pad with nothing, space, or zero (respectively).
    return fmt.replace(/%([-_0]?.)/g, function(_, c) {
      var day, dayu, mod, off_, padding, tz, y, yy;
      mod = null;
      padding = null;
      if (c.length === 2) {
        mod = c[0];
        // omit padding
        if (mod === "-") {
          padding = "";
        // pad with space
        } else if (mod === "_") {
          padding = " ";
        // pad with zero
        } else if (mod === "0") {
          padding = "0";
        } else {
          // unrecognized, return the format
          return _;
        }
        c = c[1];
      }
      switch (c) {
        case "A":
          return locale.days[d.getDay()];
        case "a":
          return locale.shortDays[d.getDay()];
        case "B":
          return locale.months[d.getMonth()];
        case "b":
          return locale.shortMonths[d.getMonth()];
        case "C":
          return pad(Math.floor(d.getFullYear() / 100), padding);
        case "D":
          return _strftime(locale.formats.D || "%m/%d/%y", d, locale);
        case "d":
          return pad(d.getDate(), padding);
        case "e":
          return d.getDate();
        case "F":
          return _strftime(locale.formats.F || "%Y-%m-%d", d, locale);
        case "H":
          return pad(d.getHours(), padding);
        case "h":
          return locale.shortMonths[d.getMonth()];
        case "I":
          return pad(hours12(d), padding);
        case "j":
          y = new Date(d.getFullYear(), 0, 1);
          day = Math.ceil((d.getTime() - y.getTime()) / (1000 * 60 * 60 * 24));
          return pad(day, 3);
        case "k":
          return pad(d.getHours(), (padding === void 0 ? " " : padding));
        case "L":
          return pad(Math.floor(timestamp % 1000), 3);
        case "l":
          return pad(hours12(d), (padding === void 0 ? " " : padding));
        case "M":
          return pad(d.getMinutes(), padding);
        case "m":
          return pad(d.getMonth() + 1, padding);
        case "n":
          return "\n";
        case "o":
          return String(d.getDate()) + ordinal(d.getDate());
        case "P":
          return ''; // (if d.getHours() < 12 then locale.am else locale.pm)
        case "p":
          return ''; // (if d.getHours() < 12 then locale.AM else locale.PM)
        case "R":
          return _strftime(locale.formats.R || "%H:%M", d, locale);
        case "r":
          return _strftime(locale.formats.r || "%I:%M:%S %p", d, locale);
        case "S":
          return pad(d.getSeconds(), padding);
        case "s":
          return Math.floor(timestamp / 1000);
        case "T":
          return _strftime(locale.formats.T || "%H:%M:%S", d, locale);
        case "t":
          return "\t";
        case "U":
          return pad(weekNumber(d, "sunday"), padding);
        case "u":
          dayu = d.getDay();
          if (dayu === 0) {
            return 7;
          } else {
            return dayu; // 1 - 7, Monday is first day of the
          }
        // week
        case "v":
          return _strftime(locale.formats.v || "%e-%b-%Y", d, locale);
        case "W":
          return pad(weekNumber(d, "monday"), padding);
        case "w":
          return d.getDay(); // 0 - 6, Sunday is first day of the
        // week
        case "Y":
          return d.getFullYear();
        case "y":
          yy = String(d.getFullYear());
          return yy.slice(yy.length - 2);
        case "Z":
          if (options.utc) {
            return "GMT";
          } else {
            tz = d.toString().match(/\((\w+)\)/);
            return tz && tz[1] || "";
          }
          break;
        case "z":
          if (options.utc) {
            return "+0000";
          } else {
            off_ = (typeof options.timezone === "number" ? options.timezone : -d.getTimezoneOffset());
            return (off_ < 0 ? "-" : "+") + pad(Math.abs(off_ / 60)) + pad(off_ % 60);
          }
          break;
        default:
          return c;
      }
    });
  };

  dateToUTC = function(d) {
    var msDelta;
    msDelta = (d.getTimezoneOffset() || 0) * 60000;
    return new Date(d.getTime() + msDelta);
  };

  quacksLikeDate = function(x) {
    var i, n;
    i = 0;
    n = RequiredDateMethods.length;
    i = 0;
    while (i < n) {
      if (typeof x[RequiredDateMethods[i]] !== "function") {
        return false;
      }
      ++i;
    }
    return true;
  };

  // Default padding is '0' and default length is 2, both are optional.
  pad = function(n, padding, length) {
    var s;
    // pad(n, <length>)
    if (typeof padding === "number") {
      length = padding;
      padding = "0";
    }
    // Defaults handle pad(n) and pad(n, <padding>)
    if (padding == null) {
      padding = "0";
    }
    if (length == null) {
      length = 2;
    }
    s = String(n);
    if (padding) {
      while (s.length < length) {
        // padding may be an empty string, don't loop forever if it is
        s = padding + s;
      }
    }
    return s;
  };

  hours12 = function(d) {
    var hour;
    hour = d.getHours();
    if (hour === 0) {
      hour = 12;
    } else {
      if (hour > 12) {
        hour -= 12;
      }
    }
    return hour;
  };

  // Get the ordinal suffix for a number: st, nd, rd, or th
  ordinal = function(n) {
    var i, ii;
    i = n % 10;
    ii = n % 100;
    if ((ii >= 11 && ii <= 13) || i === 0 || i >= 4) {
      return "th";
    }
    switch (i) {
      case 1:
        return "st";
      case 2:
        return "nd";
      case 3:
        return "rd";
    }
  };

  // firstWeekday: 'sunday' or 'monday', default is 'sunday'

  // Pilfered & ported from Ruby's strftime implementation.
  weekNumber = function(d, firstWeekday) {
    var firstDayOfYear, wday, weekNum, yday;
    firstWeekday = firstWeekday || "sunday";
    // This works by shifting the weekday back by one day if we
    // are treating Monday as the first day of the week.
    wday = d.getDay();
    if (firstWeekday === "monday") {
      if (wday === 0) { // Sunday
        wday = 6;
      } else {
        wday--;
      }
    }
    firstDayOfYear = new Date(d.getFullYear(), 0, 1);
    yday = (d - firstDayOfYear) / 86400000;
    weekNum = (yday + 7 - wday) / 7;
    return Math.floor(weekNum);
  };

  "use strict";

  namespace = api.tools;

  dayNames = [gettext("Sunday"), gettext("Monday"), gettext("Tuesday"), gettext("Wednesday"), gettext("Thursday"), gettext("Friday"), gettext("Saturday")];

  monthNames = [gettext("January"), gettext("February"), gettext("March"), gettext("April"), gettext("May"), gettext("June"), gettext("July"), gettext("August"), gettext("September"), gettext("October"), gettext("November"), gettext("December")];

  DefaultLocale = {
    days: dayNames,
    shortDays: initialsOf(dayNames),
    months: monthNames,
    shortMonths: initialsOf(monthNames),
    AM: "AM",
    PM: "PM",
    am: "am",
    pm: "pm"
  };

  namespace.djangoFormat = function(format) {
    return format.replace(/./g, function(c) {
      switch (c) {
        case "a":
        case "A":
          return "%p";
        case "b":
        case "d":
        case "m":
        case "w":
        case "W":
        case "y":
        case "Y":
          return "%" + c;
        case "c":
          return "%FT%TZ";
        case "D":
          return "%a";
        case "e":
          return "%z";
        case "f":
          return "%I:%M";
        case "F":
          return "%F";
        case "h":
        case "g":
          return "%I";
        case "H":
        case "G":
          return "%H";
        case "i":
          return "%M";
        case "I":
          return "";
        case "j":
          return "%d";
        case "l":
          return "%A";
        case "L":
          return "";
        case "M":
          return "%b";
        case "n":
          return "%m";
        case "N":
          return "%b";
        case "o":
          return "%W";
        case "O":
          return "%z";
        case "P":
          return "%R %p";
        case "r":
          return "%a, %d %b %Y %T %z";
        case "s":
          return "%S";
        case "S":
          return "";
        case "t":
          return "";
        case "T":
          return "%Z";
        case "u":
          return "0";
        case "U":
          return "";
        case "z":
          return "%j";
        case "Z":
          return "z";
        default:
          return c;
      }
    });
  };

  namespace.strftime = strftime;

  namespace.strftimeTZ = strftime.strftimeTZ = strftimeTZ;

  namespace.strftimeUTC = strftime.strftimeUTC = strftimeUTC;

  namespace.localizedStrftime = strftime.localizedStrftime = localizedStrftime;

  RequiredDateMethods = ["getTime", "getTimezoneOffset", "getDay", "getDate", "getMonth", "getFullYear", "getYear", "getHours", "getMinutes", "getSeconds"];

  return;

}).call(this);
