const setupPoliciesTable = function(itemApi) {
/*  itemApi - это экземпляр класса BasicModelRest,
который отвечает за работу с rest методами */
  "use strict";

	const policiesTable = $('#policiesTable');
    const editItemModal = $('#editItemModal');

    const toolbarBuilder = function(jToolbar) {
    	const obj = {
    		jSelf: jToolbar,
    		disableItemControls: function() {
    			const editBtn = this.jSelf.find('[data-js=item-edit]');
    	        editBtn.prop("disabled", true);
    		},
    		enableItemControls: function(item) {
    			const editBtn = this.jSelf.find('[data-js=item-edit]');

    	        editBtn.prop("disabled", false);
    	        editBtn.get(0).dataset.type=item.type;
    	        editBtn.get(0).dataset.id=item.id;
    	    	editBtn.get(0).dataset.name=item.name;
    		}
    	}

    	return obj;
    }

    const policiesToolbar = toolbarBuilder($('#policiesToolbar'));

	const initTable = function(jTable) {
		// DataTable Config
		jTable.DataTable({
		  columns: [
		    { data: null,
	    	  render: function (data, type, full, meta) {
		        return '<span data-js="item" data-type="'+data.data_type+'" data-id="'+data.data_type+'">'+data.name+'</span>';
		      }
		    },
		    { data: "view_value" },
		  ],
		  data: [],
		  dom: "t",
		  language: {
		    zeroRecords: "Список пуст"
		  },
		  order: [[ 0, 'asc' ]],
		  pfConfig: {
		    toolbarSelector: "#policiesToolbar",
		    colvisMenuSelector: '.table-view-pf-colvis-menu',
		    paginationSelector: "#policiesPagination"
		  },
		  select: {
		    selector: 'tr',
		    style: 'single'
		  },
		});
	};

	termidesk.forms.setupItemUI({
			itemApi: itemApi,
			jTable: policiesTable,
			modals: {
				edit:editItemModal,
			},
			itemToolbar: policiesToolbar,
	});

	initTable(policiesTable);
	termidesk.forms.populateTable(itemApi, policiesTable, policiesToolbar);
};