(function() {
"use strict";
	
	var termidesk = this.termidesk;
	termidesk.web = termidesk.web != null ? termidesk.web : {};
	
	const web = termidesk.web;
	web.page = {};
	web.page.context = {};
	
	web.page.setupContextRefresh = function ({
		url,
    	startInt = 30,
    	maxInt = 300,
    	throttleInt = 30,
    	step = 10
    } = {}) {
    	
    	const throttle = termidesk.utils.throttle;
    	const updateDict = termidesk.utils.updateDict;
    	const throttleIntMs = throttleInt*1000;
    	let timerHandle;
    	let accumulatedInt = 0;
    	
    	function retrieve() {
    		const self = retrieve
    		clearTimeout(timerHandle);
    		//console.log(`refresh: cleared timer ${timerHandle}`);
    		
    		let nextInt = startInt + accumulatedInt;
    		if ( nextInt > maxInt) {
    			nextInt = maxInt;
    		} else {
    			accumulatedInt+=step;
    		}
    		const nextIntMs = nextInt * 1000;
    		
    		var options = {
    			credentials: 'same-origin',
    			headers: {
    			  'Accept': 'application/json',
    			  'Content-Type': 'application/json'
    			}
    		}
    		
    		fetch(
    		  url, 
    		  options
    		)
    		.then(function(response) {
    			if (!response.ok) {
    		        throw Error(response.statusText);
    		    }
    			return response.json(); 
    		})
    	    .then(function(json) {
    	    	updateDict(window.termidesk.web.page.context, json);
    	    	setTimeout(function() {
    	    		$('[data-toggle="tooltip"]').tooltip();	
    	    	}, 10)
    	    	timerHandle = setTimeout(self, nextIntMs);
    	    	//console.log(`refresh: timer ${timerHandle} next run in ${nextIntMs}`);
    	    })
    	    .catch(function(error) {
    	    	console.log(error);
    	    	timerHandle = setTimeout(self, nextIntMs);
    	    	//console.log(`refresh: timer ${timerHandle} next run in ${nextIntMs}`);
    	    });
    		
    	}
    	
    	const throttledRetrieve = throttle(retrieve, throttleIntMs);
    	
    	function onMouseMove(event) {
    		accumulatedInt = 0;
    		throttledRetrieve();
    	}
    	
    	document.addEventListener('mousemove', onMouseMove);
    }
	
}).call(this);