from django import template
from uds.core.util.Config import GlobalConfig
from uds.models.User import User

register = template.Library()


@register.simple_tag(name='is_rbac_enabled')
def is_rbac_enabled():
    return GlobalConfig.EXPERIMENTAL_RBAC_ENABLED.getInt(force=True) != 0


@register.simple_tag(name="is_policies_enabled")
def is_policies_enabled(user: User):
    return GlobalConfig.EXPERIMENTAL_POLICIES_ENABLED.getInt(force=True) != 0 and user.is_admin
