# -*- coding: utf-8 -*-
'''
Created on 11 янв. 2019 г.

@author: dvd
'''
from __future__ import unicode_literals

from django.utils.translation import ugettext as _
from django.http import HttpResponse, HttpResponseRedirect
from django.shortcuts import render
from django.template import RequestContext
from django.views.decorators.cache import cache_page, never_cache

from uds.core.auths.auth import webLoginRequired
from uds.core.managers import userServiceManager, cryptoManager
from uds.models import TicketStore
from uds.core.ui.images import DEFAULT_IMAGE
from uds.core.ui import theme
from uds.core.util.model import processUuid
from uds.models import Transport, Image
from uds.core.util import html
from uds.core.services.Exceptions import ServiceNotReadyError, MaxServicesReachedError, ServiceAccessDeniedByCalendar

from uds.models import UserService
from uds.core.util.State import State

import uds.web.errors as errors

from termidesk.license.exceptions import LicenseMaxActiveWorkplacesReachedError
from termidesk import __version__ as static_revision

import six
import json
import logging
from termidesk.core.util import wsptoken
import config

logger = logging.getLogger(__name__)

@webLoginRequired(admin=False)
@never_cache
def index(request, ticketId):
    context = {}
    params = TicketStore.get(ticketId, invalidate=False)
    context['spice_params'] = params
    
    secure = True
    target_host = params['host']
    target_port = params['tls-port']
    tun_lifetime = params['tunnelWait']
    
    if params['tls-port'] == -1:
        secure = False
        target_port = params['port']

    wstoken_data = {
        'host': target_host,
        'port': target_port,
        'ssl_target': secure,
    }
    
    with open(config.WSPROXY_PRIV_KEY_FILE) as f:
        sign_key = f.read()

    wstoken = wsptoken.TokenEncoder(sign_key, lifetime=tun_lifetime).encode(wstoken_data)
    context['wstoken'] = wstoken
    context['static_revision'] = static_revision
    return render(request, 'termidesk/clients/html5spice/index.html', context=context)
