# -*- coding: utf-8 -*-


import os
from time import sleep

if __name__ == "__main__":
    try:
        os.environ.setdefault("DJANGO_SETTINGS_MODULE", "server.settings")
        import django
        django.setup()

        from uds.core.util.Config import GlobalConfig
        GlobalConfig.initialize()
        from django.conf import settings
        use_celery = settings.USE_CELERY

        if not use_celery:
            from uds.core.managers.TaskManager import TaskManager

            manager = TaskManager()
            manager.run()
        else:
            sleep(1)
    except Exception as e:
        # В python 3.5.3 возникает ошибка
        # TypeError: 'NoneType' object is not callable
        # на этапе сбора мусора
        import traceback
        print(traceback.format_exc())
