# Generated by Django 2.2.17 on 2021-03-24 14:41

from django.db import migrations


def fix_pksvbrestprov_plugin_service_type(apps, schema_editor):
    # We can't import the Person model directly as it may be a newer
    # version than this migration expects. We use the historical version.
    pksvbrest_provider_type = "pksvbrestPlatform"
    old_pksvbrest_service_type = "horizontVSLiveService"
    new_pksvbrest_service_type = "pksvbrestLiveService"

    target_provider = apps.get_model('uds', 'Provider')
    pksvbrest_providers = target_provider.objects.filter(data_type=pksvbrest_provider_type).all()
    target_service = apps.get_model('uds', 'Service')
    pksvbrest_services = target_service.objects.filter(provider__in=pksvbrest_providers,
                                                       data_type=old_pksvbrest_service_type).all()
    for service_to_fix in pksvbrest_services:
        service_to_fix.data_type = new_pksvbrest_service_type
        service_to_fix.save()


class Migration(migrations.Migration):

    dependencies = [
        ('uds', '0030_deployedservicepublication_reason'),
    ]

    operations = [
        migrations.RunPython(fix_pksvbrestprov_plugin_service_type),
    ]
