# Generated by Django 2.2.17 on 2021-06-10 12:27

from django.db import migrations
from django.db.models import F


def move_initial_srvs_to_cache_l1_srvs(apps, schema_editor):
    """Замена значения `cache_l1_srvs` на `initial_srvs`, если `initial_srvs` > `cache_l1_srvs`"""
    deployed_service_model = apps.get_model('uds', 'DeployedService')
    # Выбираем записи для которых соблюдается правило `initial_srvs` > `cache_l1_srvs`
    target_deployed_services = deployed_service_model.objects.filter(initial_srvs__gt=F('cache_l1_srvs'))
    for service_to_fix in target_deployed_services.all():
        if service_to_fix.cache_l1_srvs < service_to_fix.initial_srvs:
            service_to_fix.cache_l1_srvs = service_to_fix.initial_srvs
            service_to_fix.save()


class Migration(migrations.Migration):

    dependencies = [
        ('uds', '0036_remove_uds_label_from_config'),
    ]

    operations = [
        migrations.RunPython(move_initial_srvs_to_cache_l1_srvs),
    ]
