# Generated by Django 2.2.17 on 2021-06-10 12:41

from django.db import migrations


def clear_initial_srvs(apps, schema_editor):
    """Обнуление `initial_srvs`"""
    deployed_service_model = apps.get_model('uds', 'DeployedService')
    # Исключаем записи в которых `initial_srvs` уже равен 0
    target_deployed_services = deployed_service_model.objects.exclude(initial_srvs=0)
    for service_to_clear in target_deployed_services.all():
        service_to_clear.initial_srvs = 0
        service_to_clear.save()


class Migration(migrations.Migration):

    dependencies = [
        ('uds', '0037_move_initial_srvs_to_cache_l1_srvs'),
    ]

    operations = [
        migrations.RunPython(clear_initial_srvs),
    ]
