# Generated by Django 2.2.17 on 2021-07-22 16:46

from django.db import migrations


def remove_syslog_port(apps, schema_editor):
    """Удаление порта syslog сервера"""
    from django.core.exceptions import ObjectDoesNotExist
    config_model = apps.get_model('uds', 'Config')
    try:
        from uds.core.util.Config import MONITORING_SECTION
        port_record = config_model.objects.get(section=MONITORING_SECTION, key='port')

        from logging.handlers import SYSLOG_UDP_PORT, SYSLOG_TCP_PORT
        if port_record.value not in (str(SYSLOG_UDP_PORT), str(SYSLOG_TCP_PORT)):
            from uds.core.util.Config import GlobalConfig
            host_record = config_model.objects.\
                get(section=MONITORING_SECTION, key=GlobalConfig.SYSLOG_HOST.key())
            host_record.value = ':'.join((host_record.value, port_record.value))
            host_record.save()

        port_record.delete()
    except config_model.DoesNotExist:
        pass


class Migration(migrations.Migration):

    dependencies = [
        ('uds', '0039_remove_deployedservice_initial_srvs'),
    ]

    operations = [
        migrations.RunPython(remove_syslog_port),
    ]
