# Generated by Django 2.2.17 on 2021-08-05 18:01

from django.db import migrations


def rename_configuration_keys(apps, schema_editor):
    """Переименование ключей конфигурационных параметров"""
    config_keys_mapping = [
        # Audit
        {
            "section": "Audit",
            "key": "audit db delete records at once",
            "new_key": "audit.db.delete.recordsAtOnce",
        },
        {
            "section": "Audit",
            "key": "audit db log delete timeout",
            "new_key": "audit.db.log.deleteTimeout",
        },
        {
            "section": "Audit",
            "key": "audit db log enable",
            "new_key": "audit.db.log.enable",
        },
        {
            "section": "Audit",
            "key": "audit filehandler backups",
            "new_key": "audit.fileHandler.backups",
        },
        {
            "section": "Audit",
            "key": "audit filehandler enable",
            "new_key": "audit.fileHandler.enable",
        },
        {
            "section": "Audit",
            "key": "audit filehandler path",
            "new_key": "audit.fileHandler.path",
        },
        {
            "section": "Audit",
            "key": "audit strict mode enable",
            "new_key": "audit.strictMode.enable",
        },
        {
            "section": "Audit",
            "key": "audit syslog enable",
            "new_key": "audit.syslog.enable",
        },
        {
            "section": "Audit",
            "key": "audit syslog facility",
            "new_key": "audit.syslog.facility",
        },
        {
            "section": "Audit",
            "key": "audit syslog host",
            "new_key": "audit.syslog.host",
        },
        {
            "section": "Audit",
            "key": "audit syslog port",
            "new_key": "audit.syslog.port",
        },
        {
            "section": "Audit",
            "key": "audit syslog socket",
            "new_key": "audit.syslog.socket",
        },
        # Cluster
        {
            "section": "Cluster",
            "key": "Destination CPU Load",
            "new_key": "cluster.destinationCPULoad",
        },
        {
            "section": "Cluster",
            "key": "Migration CPU Load",
            "new_key": "cluster.migrationCPULoad",
        },
        {
            "section": "Cluster",
            "key": "Migration Free Memory",
            "new_key": "cluster.migrationFreeMemory",
        },
        # Global
        {
            "section": "Global",
            "key": "allowPreferencesAccess",
            "new_key": "global.allowPreferencesAccess",
        },
        {
            "section": "Global",
            "key": "autorunService",
            "new_key": "global.autorunService",
        },
        {
            "section": "Global",
            "key": "cacheCheckDelay",
            "new_key": "global.cacheCheckDelay",
        },
        {
            "section": "Global",
            "key": "Calendar access denied text",
            "new_key": "global.calendar.accessDeniedText",
        },
        {
            "section": "Global",
            "key": "checkUnusedTime",
            "new_key": "global.checkUnusedTime",
        },
        {
            "section": "Global",
            "key": "cleanupCheck",
            "new_key": "global.cleanupCheck",
        },
        {
            "section": "Global",
            "key": "customHtmlLogin",
            "new_key": "global.customHtmlLogin",
        },
        {
            "section": "Global",
            "key": "delayedTasksThreads",
            "new_key": "global.delayedTasksThreads",
        },
        {
            "section": "Global",
            "key": "disallowGlobalLogin",
            "new_key": "global.disallowGlobalLogin",
        },
        {
            "section": "Global",
            "key": "ignoreLimits",
            "new_key": "global.ignoreLimits",
        },
        {
            "section": "Global",
            "key": "keepInfoTime",
            "new_key": "global.keepInfoTime",
        },
        {
            "section": "Global",
            "key": "loginBlockTime",
            "new_key": "global.loginBlockTime",
        },
        {
            "section": "Global",
            "key": "loginUrl",
            "new_key": "global.loginUrl",
        },
        {
            "section": "Global",
            "key": "maxInitTime",
            "new_key": "global.maxInitTime",
        },
        {
            "section": "Global",
            "key": "maxLoginTries",
            "new_key": "global.maxLoginTries",
        },
        {
            "section": "Global",
            "key": "maxLogPerElement",
            "new_key": "global.maxLogPerElement",
        },
        {
            "section": "Global",
            "key": "maxPreparingServices",
            "new_key": "global.maxPreparingServices",
        },
        {
            "section": "Global",
            "key": "maxRemovingServices",
            "new_key": "global.maxRemovingServices",
        },
        {
            "section": "Global",
            "key": "Page reload Time",
            "new_key": "global.pageReloadTime",
        },
        {
            "section": "Global",
            "key": "redirectToHttps",
            "new_key": "global.redirectToHttps",
        },
        {
            "section": "Global",
            "key": "removalCheck",
            "new_key": "global.removalCheck",
        },
        {
            "section": "Global",
            "key": "restrainCount",
            "new_key": "global.restrainCount",
        },
        {
            "section": "Global",
            "key": "restrainTime",
            "new_key": "global.restrainTime",
        },
        {
            "section": "Global",
            "key": "schedulerThreads",
            "new_key": "global.schedulerThreads",
        },
        {
            "section": "Global",
            "key": "sessionExpireTime",
            "new_key": "global.sessionExpireTime",
        },
        {
            "section": "Global",
            "key": "statsDuration",
            "new_key": "global.statsDuration",
        },
        {
            "section": "Global",
            "key": "Theme",
            "new_key": "global.theme",
        },
        {
            "section": "Global",
            "key": "Theme Enhaced",
            "new_key": "global.themeEnhanced",
        },
        {
            "section": "Global",
            "key": "userServiceCleanNumber",
            "new_key": "global.userServiceCleanNumber",
        },
        # IPAUTH
        {
            "section": "IPAUTH",
            "key": "authentication error custom message",
            "new_key": "ipauth.authentication.error.customMessage",
        },
        {
            "section": "IPAUTH",
            "key": "autoLogin",
            "new_key": "ipauth.autoLogin",
        },
        # Monitoring
        {
            "section": "Monitoring",
            "key": "enable syslog",
            "new_key": "monitoring.syslog.enable",
        },
        {
            "section": "Monitoring",
            "key": "facility",
            "new_key": "monitoring.syslog.facility",
        },
        {
            "section": "Monitoring",
            "key": "host",
            "new_key": "monitoring.syslog.host",
        },
        {
            "section": "Monitoring",
            "key": "host_2",
            "new_key": "monitoring.syslog.host_2",
        },
        {
            "section": "Monitoring",
            "key": "host_3",
            "new_key": "monitoring.syslog.host_3",
        },
        {
            "section": "Monitoring",
            "key": "levelName",
            "new_key": "monitoring.syslog.levelName",
        },
        {
            "section": "Monitoring",
            "key": "socket",
            "new_key": "monitoring.syslog.socket",
        },
        # Security
        {
            "section": "Security",
            "key": "adminIdleTime",
            "new_key": "security.adminIdleTime",
        },
        {
            "section": "Security",
            "key": "allowRootWebAccess",
            "new_key": "security.allowRootWebAccess",
        },
        {
            "section": "Security",
            "key": "Behind a proxy",
            "new_key": "security.behindProxy",
        },
        {
            "section": "Security",
            "key": "Exclusive Logout",
            "new_key": "security.exclusiveLogout",
        },
        {
            "section": "Security",
            "key": "honorClientNotifyIP",
            "new_key": "security.honorClientNotifyIP",
        },
        {
            "section": "Security",
            "key": "Master Key",
            "new_key": "security.masterKey",
        },
        {
            "section": "Security",
            "key": "rootPam",
            "new_key": "security.rootPam",
        },
        {
            "section": "Security",
            "key": "rootPass",
            "new_key": "security.rootPass",
        },
        {
            "section": "Security",
            "key": "superUser",
            "new_key": "security.superUser",
        },
        {
            "section": "Security",
            "key": "Trusted Hosts",
            "new_key": "security.trustedHosts",
        },
        {
            "section": "Security",
            "key": "userSessionLength",
            "new_key": "security.userSessionLength",
        },
        # Plugins
        {
            "section": "NX",
            "key": "downloadUrl",
            "new_key": "nx.downloadUrl",
        },
        {
            "section": "NX",
            "key": "downloadUrlMACOS",
            "new_key": "nx.downloadUrlMACOS",
        },
    ]

    configuration_model = apps.get_model('uds', 'Config')
    for param_keys_mapping in config_keys_mapping:
        try:
            db_param = configuration_model.objects.filter(section=param_keys_mapping['section'])\
                .get(key=param_keys_mapping['key'])
            db_param.key = param_keys_mapping['new_key']

            # Для исключения IntegrityError, перед сохранением
            # необходимо удалить запись с новым ключом, если она есть
            configuration_model.objects.\
                filter(section=param_keys_mapping['section'], key=param_keys_mapping['new_key']).delete()

            db_param.save()
        except configuration_model.DoesNotExist:
            # Конфигурационного ключа в БД не оказалось
            # Обычно не является проблемой.
            # Скорее всего, у нас установка с нуля.
            pass


class Migration(migrations.Migration):

    dependencies = [
        ('uds', '0040_remove_syslog_port_from_monitoring_section'),
    ]

    operations = [
        migrations.RunPython(rename_configuration_keys),
    ]
