# Generated by Django 2.2.17 on 2021-09-27 13:41

from django.db import migrations

from uds.core.util.State import State


def remove_unused_user_state(apps, schema_editor):
    """Удаление неиспользуемого состояния пользователя Заблокирован"""
    old_state = State.BLOCKED
    new_state = State.INACTIVE

    user_model = apps.get_model('uds', 'User')
    inactive_users = user_model.objects.filter(state=old_state)
    for inactive_user in inactive_users:
        inactive_user.state = new_state
        inactive_user.save()


class Migration(migrations.Migration):

    dependencies = [
        ('uds', '0041_rename_configuration_keys'),
    ]

    operations = [
        migrations.RunPython(remove_unused_user_state),
    ]
