# This is a template
# Saved as .py for easier editing
from __future__ import unicode_literals

# pylint: disable=import-error, no-name-in-module
import os
import glob
import subprocess

from client import tools  # @UnresolvedImport

# Lets find remote viewer
# There is a bug that when installed, the remote viewer (at least 64 bits version) does not store correctly its path, so lets find it "a las bravas"
extraPaths = ()
for env in ('PROGRAMFILES', 'PROGRAMW6432'):
    if env in os.environ:
        extraPaths += tuple(p + '\\bin' for p in glob.glob(os.environ[env] + '\\VirtViewer*'))

executable = tools.findApp('{m.client_filename}.exe', extraPaths)

if executable is None:
    raise Exception('''<p>You need to have installed {m.client_filename} to connect to this VDI service.</p>
<p>
    Please, install appropriate package for your system.
</p>
''')

theFile = '''{m.r.as_file}'''

try:
    filename = tools.saveTempFile(theFile)
except Exception as e:
    filename = tools.saveTempFile(theFile, suffix=".vv")

subprocess.Popen([executable, filename])
