# This is a template
# Saved as .py for easier editing
from __future__ import unicode_literals

# pylint: disable=import-error, no-name-in-module, undefined-variable
import os
import glob
import subprocess

from client import tools  # @UnresolvedImport
from client.wstunnel import wstunnel # @UnresolvedImport

# Lets find remote viewer
# There is a bug that when installed, the remote viewer (at least 64 bits version) does not store correctly its path, so lets find it "a las bravas"
extraPaths = ()
for env in ('PROGRAMFILES', 'PROGRAMW6432'):
    if env in os.environ:
        extraPaths += tuple(p + '\\bin' for p in glob.glob(os.environ[env] + '\\VirtViewer*'))

executable = tools.findApp('{m.client_filename}.exe', extraPaths)

if executable is None:
    raise Exception('''<p>You need to have installed virt-viewer to connect to this VDI service.</p>
<p>
    Please, install appropriate package for your system.
</p>
<p>
    <a href="http://virt-manager.org/download/">Open download page</a>
</p>
''')

if {m.port} != -1:  # @UndefinedVariable
    forwardThread1, port = wstunnel('{m.tun_url}', {m.port}, timeout={m.tun_lifetime})  # @UndefinedVariable

    if forwardThread1.status == 2:
        raise Exception('Unable to open tunnel')
else:
    port = -1

if {m.secure_port} != -1:  # @UndefinedVariable
    forwardThread2, secure_port = wstunnel('{m.tun_secure_url}', {m.secure_port}, timeout={m.tun_lifetime})  # @UndefinedVariable

    if forwardThread2.status == 2:
        raise Exception('Unable to open tunnel')
else:
    secure_port = -1

theFile = '''{m.r.as_file}'''.format(
    secure_port=secure_port,
    port=port
)

try:
    filename = tools.saveTempFile(theFile)
except Exception as e:
    filename = tools.saveTempFile(theFile, suffix=".vv")

subprocess.Popen([executable, filename])
